#  KillDemo.pl
#  Example: 7.19
#  ----------------------------------------
#  From "Win32 Perl Scripting: Administrators Handbook" by Dave Roth
#  Published by New Riders Publishing.
#  ISBN # 1-57870-215-1
#
#  This script demonstrates how to kill a process using Perl's kill() function.

use Win32;
my $Path = "$ENV{SystemRoot}";
my $Program = "notepad.exe";
my $App = "$Path\\$Program";
my $Args = "$Program $ENV{Temp}\\test.txt ";
my $Pid = 0;
my $Time = 10;

print "Creating new process: $Program\n";
if( Win32::Spawn( $App, $Args, $Pid ) )
{
    print "Waiting for $Time seconds...\n";
    sleep( $Time );

    print "Killing PID $Pid\n";
    kill 0, $Pid;
}
else
{
    print "Could not create the process.\n";
    print "Error: " . Win32::FormatMessage( Win32::GetLastError() ) . "\n";
}
